/* test */

#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <math.h>
#include "odicon.h"
#include "lseparable.h"


static void test(int dim, double f(int,int*), int init1[], int init2[], int *limit) {
    double ans;
    int x[1000];

    printf("--------------------------\n");
    printf("Wolfe + relax\n");
    ivector_copy(dim, x, init1);
    ans = lgconv_minimize_FW(dim, f, x);

    if (dim > limit[0]) return;
    printf("--------------------------\n");
    printf("IFF + relax\n");
    ivector_copy(dim, x, init1);
    if (fcmp(ans,lgconv_minimize_IFF(dim, f, x)) != 0) exit(1);

    printf("--------------------------\n");
    printf("Wolfe + scaling\n");
    ivector_copy(dim, x, init2);
    if (fcmp(ans,lgconv_minimize_scaling_FW(dim, f, x)) != 0) exit(1);

    if (dim > limit[1]) return;
    printf("--------------------------\n");
    printf("IFF + scaling\n");
    ivector_copy(dim, x, init2);
    if (fcmp(ans,lgconv_minimize_scaling_IFF(dim, f, x)) != 0) exit(1);

    if (dim > limit[2]) return;
    printf("--------------------------\n");
    printf("Wolfe\n");
    ivector_copy(dim, x, init2);
    if (fcmp(ans,lgconv_minimize_FW(dim, f, x)) != 0) exit(1);

    printf("--------------------------\n");
    printf("IFF\n");
    ivector_copy(dim, x, init2);
    if (fcmp(ans,lgconv_minimize_IFF(dim, f, x)) != 0) exit(1);

    if (dim > limit[3]) return;
    printf("--------------------------\n");
    printf("2^n + relax\n");
    ivector_copy(dim, x, init1);
    if (fcmp(ans,lgconv_minimize(dim, f, x)) != 0) exit(1);

    /* return; */

    if (dim > limit[4]) return;
    printf("--------------------------\n");
    printf("2^n + scaling\n");
    ivector_copy(dim, x, init2);
    if (fcmp(ans,lgconv_minimize_scaling(dim, f, x)) != 0) exit(1);

    if (dim > limit[5]) return;
    printf("--------------------------\n");
    printf("2^n\n");
    ivector_copy(dim, x, init2);
    if (fcmp(ans,lgconv_minimize(dim, f, x)) != 0) exit(1);
    return;

    if (dim > limit[4]) return;
    printf("--------------------------\n");
    printf("2^n + scaling, L#\n");
    ivector_copy(dim, x, init2);
    ans = lconv_minimize_scaling(dim, f, x, 1);

    if (dim > limit[5]) return;
    printf("--------------------------\n");
    printf("2^n, L#\n");
    ivector_copy(dim, x, init2);
    if (fcmp(ans,lconv_minimize(dim, f, x, 1)) != 0) exit(1);
}

static struct lseparable_st *lseparable_inst;
static double ffunc(int dim, double x[]) { return lseparable(dim, x, lseparable_inst); }
/*static double ifunc(int dim, int x[]) { return int_func(dim, ffunc, x); }*/
static double ifunc(int dim, int x[]) { return intint_func(dim, ffunc, x); }

void test_lconv2(const int dim, int argc, char** argv) {
    int i;
    double *fans = fvector_new(dim, 190, -200, 200);
    int    *ians = ivector_new(dim, 190, -200, 200);
    int    *init = ivector_new(dim, 190, -200, 200); /* starting point */
    int limit[6] = { 80, 70, 40, 24, 20, 15 };

    for (i=0; i<dim; i++) {
        fans[i] = init[i] = irandom(-10*dim, +10*dim);
    }
    /*
    {int data[] = {-19, -14, 33, -29};
    for (i=0; i<dim; i++) init[i] = data[i];}
    */

    lseparable_inst = lseparable_make(dim);
#ifdef DEBUG    
    lseparable_output(lseparable_inst);
#endif /* DEBUG */
    lbfgs_call(dim, ffunc, fans);
    for (i=0; i<dim; i++) ians[i] = (int)floor(0.5 + fans[i]);
    printf("--------------------------\n");
    printf("continus\n");
    counter_println();
    minimizer_print(dim, ifunc, ians);

    for (i=4; i<argc; i++) limit[i-4] = atoi(argv[i]);
    test(dim, ifunc, ians, init, limit);
}
